unit uFMM;

interface

uses uTypes;

PROCEDURE SPLINE (VAR X, Y, B, C, D : TARe);
PROCEDURE SPLINE4(VAR X, Y, B, C, D : TAR4);

FUNCTION SEVAL  (N:INTEGER; U:REAL; VAR X, Y, B, C, D : TARe):REAL;
FUNCTION SEVAL_I(I:INTEGER; U:REAL; VAR X, Y, B, C, D : TARe):REAL;


procedure QUANC8(FUN:TFuncEX;A,B,ABSERR,RELERR:Extended;
                 var RESULT,ERREST:Extended;
                 var NOFUN:integer;var FLAG:Extended);

implementation


(*
 *  - 
 * . .,.,.
 * "   "
 *     .,"",1980, .86 - 94.
 *)

(*     SPLINE  SEVAL  (c) .. 1992 *)

 PROCEDURE SPLINE(VAR X, Y, B, C, D : TARe);
 (*
  *  - B[I],C[I]  D[I], I=1,2, ..., N,
  *    
  *
  *    S(X) = Y[I] + B[I]*(X-X[I]) + C[I]*(X-X[I])**2 + D[I]*(X-X[I])**3
  *
  *     X[I] <= X <= X[I+1]
  *
  *  ..
  *
  *    N =      (N >= 2)
  *    X =      
  *     =  
  *
  *  ..
  *
  *    B,C,D =     .
  *
  *    P  , 
  *
  *    Y[I]=S(X[I])
  *    B[I]=SP(X[I])
  *    C[I]=SPP(X[I])/2
  *    D[I]=SPPP(X[I])/6  ( )
  *
  *    -
  *  SEVAL     .
  *
  *)
  VAR
    NM1, IB, I : INTEGER;
    T : REAL;
    N : integer;
  BEGIN
    N := Length(X) - 1;
    SetLength(B,N+1);
    SetLength(C,N+1);
    SetLength(D,N+1);

    NM1:=N-1;
    IF (N < 2) THEN Exit;
    IF (N < 3) THEN BEGIN
      B[1]:=(Y[2]-Y[1])/(X[2]-X[1]);  (*   *)
      C[1]:=0; D[1]:=0; B[2]:=B[1]; C[2]:=0; D[2]:=0; EXIT;
    END;

 (*
  *   
  *
  * B=, D=, C= .
  *)
    D[1]:=X[2]-X[1];
    C[2]:=(Y[2]-Y[1])/D[1];
    FOR I:=2 TO NM1 DO BEGIN
      D[I]:=X[I+1]-X[I];
      B[I]:=2*(D[I-1]+D[I]);
      C[I+1]:=(Y[I+1]-Y[I])/D[I];
      C[I]:=C[I+1]-C[I];
    END;
 (*
  *  .     X[I]  X[N]
  *     
  *)
    B[1]:=-D[1];
    B[N]:=-D[N-1];
    C[1]:=0;
    C[N]:=0;
    IF (N > 3) THEN BEGIN
      C[1]:=C[3]/(X[4]-X[2])-C[2]/(X[3]-X[1]);
      C[N]:=C[N-1]/(X[N]-X[N-2])-C[N-2]/(X[N-1]-X[N-3]);
      C[1]:=C[1]*D[1]*D[1]/(X[4]-X[1]);
      C[N]:=-C[N]*D[N-1]*D[N-1]/(X[N]-X[N-3]);
    END;
 (*
  *  
  *)
    FOR I:=2 TO N DO BEGIN
      T:=D[I-1]/B[I-1];
      B[I]:=B[I]-T*D[I-1];
      C[I]:=C[I]-T*C[I-1];
    END;
 (*
  *  
  *)
    C[N]:=C[N]/B[N];
    FOR IB:=1 TO NM1 DO BEGIN
      I:=N-IB;
      C[I]:=(C[I]-D[I]*C[I+1])/B[I];
    END;
 (*
  *  C[I]    SIGMA[I],   $4.4.
  *
  *   
  *)
    B[N]:=(Y[N]-Y[NM1])/D[NM1]+D[NM1]*(C[NM1]+2*C[N]);
    FOR I:=1 TO NM1 DO BEGIN
      B[I]:=(Y[I+1]-Y[I])/D[I]-D[I]*(C[I+1]+2*C[I]);
      D[I]:=(C[I+1]-C[I])/D[I];
      C[I]:=3*C[I];
    END;
    C[N]:=3*C[N];
    D[N]:=D[N-1];
  END; (* SPLINE *)


(*   SPLINE,    4    *)
(*   (      )               *)
 PROCEDURE SPLINE4(VAR X, Y, B, C, D : TAR4);
  VAR
    NM1, IB, I : INTEGER;
    T : REAL;
    N : integer;
  BEGIN
    N   := 4;
    NM1 := N-1;
    D[1]:=X[2]-X[1];
    C[2]:=(Y[2]-Y[1])/D[1];
    FOR I:=2 TO NM1 DO BEGIN
      D[I]:=X[I+1]-X[I];
      B[I]:=2*(D[I-1]+D[I]);
      C[I+1]:=(Y[I+1]-Y[I])/D[I];
      C[I]:=C[I+1]-C[I];
    END;
    B[1]:=-D[1];
    B[N]:=-D[N-1];
    C[1]:=0;
    C[N]:=0;
    C[1]:=C[3]/(X[4]-X[2])-C[2]/(X[3]-X[1]);
    C[N]:=C[N-1]/(X[N]-X[N-2])-C[N-2]/(X[N-1]-X[N-3]);
    C[1]:=C[1]*D[1]*D[1]/(X[4]-X[1]);
    C[N]:=-C[N]*D[N-1]*D[N-1]/(X[N]-X[N-3]);
    FOR I:=2 TO N DO BEGIN
      T:=D[I-1]/B[I-1];
      B[I]:=B[I]-T*D[I-1];
      C[I]:=C[I]-T*C[I-1];
    END;
    C[N]:=C[N]/B[N];
    FOR IB:=1 TO NM1 DO BEGIN
      I:=N-IB;
      C[I]:=(C[I]-D[I]*C[I+1])/B[I];
    END;
    B[N]:=(Y[N]-Y[NM1])/D[NM1]+D[NM1]*(C[NM1]+2*C[N]);
    FOR I:=1 TO NM1 DO BEGIN
      B[I]:=(Y[I+1]-Y[I])/D[I]-D[I]*(C[I+1]+2*C[I]);
      D[I]:=(C[I+1]-C[I])/D[I];
      C[I]:=3*C[I];
    END;
    C[N]:=3*C[N];
    D[N]:=D[N-1];
  END; (* SPLINE4 *)


 FUNCTION SEVAL(N:INTEGER;     (*   X,Y,B,C,D *)
     U:REAL;                   (*      *)
     VAR X, Y, B, C, D : TARe
     ):REAL;
 (*
  *      
  *
  *    SEVAL=Y[I]+B[I]*(U-X[I])+C[I]*(U-X[I])**2+D[I]*(U-X[I])**3
  *
  *     X[I] < U < X[I+1].   
  *
  *  U  < X[1],    I = 1.
  *  U >= X[N],    I = N.
  *
  *  
  *
  *    N =   
  *    U = ,  -   
  *    X, Y =     
  *    B, C, D =  - ,   SPLINE
  *
  *       U      ,
  *        .
  *)
  (*$J+*)(*  , -   -  *)
  CONST I : INTEGER = 1;(* .    X,   U *)
  VAR
    J, K : INTEGER;
    DX   : REAL;
  BEGIN
    IF (I <  1) THEN I:=1;
    IF (I >= N) THEN I:=N;

    IF  (U < X[I]) then begin
      J := I;
      I := 1;
      REPEAT                       (*   *)
        K:=(I+J) DIV 2;
        IF (U <  X[K]) THEN J:=K;
        IF (U >= X[K]) THEN I:=K;
      UNTIL (J <= (I+1));
    end
    else
    IF  (U > X[I]) then begin
      J := N + 1;
      REPEAT                       (*   *)
        K:=(I+J) DIV 2;
        IF (U <  X[K]) THEN J:=K;
        IF (U >= X[K]) THEN I:=K;
      UNTIL (J <= (I+1));
    end;

    DX:=U-X[I];
    SEVAL:=Y[I]+DX*(B[I]+DX*(C[I]+DX*D[I])); (*   *)
  END;

(* -    ! *)
FUNCTION SEVAL_I(I:INTEGER;   (*    *)
                 U:REAL;
             VAR X, Y, B, C, D : TARe  (*    *)
                ):REAL;
VAR DX : real;
BEGIN
  DX:=U-X[I]; SEVAL_I:=Y[I]+DX*(B[I]+DX*(C[I]+DX*D[I]));
END;















(*    *)
function iPOW(II,IP:integer):integer;
var I,IR : integer;
begin
  IR := II;
  for I := 2 to IP do IR := IR * II;
  result := IR;
end;

function MAX(X1,X2:extended):extended;
begin if X2>X1 then MAX:=X2 else MAX:=X1 end;

procedure QUANC8(FUN:TFuncEX;A,B,ABSERR,RELERR:Extended;
                 var RESULT,ERREST:Extended;
                 var NOFUN:integer;var FLAG:Extended);
//    FUN(X)        .
//   ,    -
// 8- 
//
//  ..
//
// FUN     FUN{X),   
//
//         
//          (   ,  )
//
// RELERR    (  )
// ABSERR       (  )
//
//
//  ..
//
// RESULT   , ,  , 
//            .
// ERREST    .
// NOFUN    ,    RESULT.
// FLAG    .  FLAG  ,  RESULT, ,
//           .
//         FLAG=XXXYYY,  - ,    
//        ,  O.YYY=   ,  
//           ,   
//            NOFUN.
//
var
  W0, W1, W2, W3, W4, AREA, X0, F0, STONE, STEP, COR11, TEMP : Extended;
  QPREV, QNOW, QDIFF, QLEFT, ESTERR, TOLERR                  : Extended;
//QRIGHT       : array [1..31] of Extended;
//QRIGHT       : array [1..61] of Extended;
  QRIGHT       : array [1..161] of Extended;
  F, X         : array [1..16] of Extended;
//FSAVE, XSAVE : array [1..8,1..30] of Extended;
//FSAVE, XSAVE : array [1..8,1..60] of Extended;
  FSAVE, XSAVE : array [1..8,1..120] of Extended;
  LEVMIN, LEVMAX, LEVOUT, NOMAX, NOFIN, LEV, NIM, I, J, jj : INTEGER;
  QDone,Q72 : boolean;
begin
//
// ***  1 ***   
// ,    . -
//  .
//
  LEVMIN :=    1;
  LEVMAX :=   120; // 60;    // 30
  LEVOUT :=    8;  //  7;    // 6
  NOMAX  := 20000;   // 5000  10000
  NOFIN  := NOMAX - 8 * (LEVMAX - LEVOUT + iPOW(2,(LEVOUT + 1)));
//
//  NOFUN   NOFIN, TO 
//
  W0 :=   3956/14175;
  W1 :=  23552/14175;
  W2 :=  -3712/14175;
  W3 :=  41984/14175;
  W4 := -18160/14175;
//
//     .
//
  FLAG   := 0;
  RESULT := 0;
  COR11  := 0;
  ERREST := 0;
  AREA   := 0;
  NOFUN  := 0;
  if (A = B) then Exit;
//
// *** 2***   
// ,   , 
//    
//
  LEV   := 0;
  NIM   := 1;
  X0    := A;
  X[16] := B;
  QPREV := 0;
  F0    := FUN(X0);
  STONE := (B - A)/16;
  X[8]  := (X0  +X[16])/2;
  X[4]  := (X0  +X[8] )/2;
  X[12] := (X[8]+X[16])/2;
  X[2]  := (X0  +X[4] )/2;
  X[6]  := (X[4]+X[8] )/2;
  X[10] := (X[8]+X[12])/2;
  X[14] := (X[12]+X[16])/2;

  for jj := 1 to 8 do begin J := jj*2; F[J] := FUN(X[J]); end; NOFUN := 1+8;
//
// *** 3***  
//  QPREV, 0,2,4,...,16, F0,F2,F4,...,F16.
//  X1,,...,15, F1,F3,...,F15, QLEFT, QRIGHT, QNOW, QDIFF, AREA.
//
//

/////////////////////////////////////////////////     30
  QDone := false;
  repeat

    X[1]  := (X0+X[2])/2;
    F[1]  := FUN(X[1]);
//  for J := 3 to 15 step 2 do begin
    for jj := 1 to 7 do begin
      J := 2*jj+1;
      X[J] := (X[J-1]+X[J+1])/2;
      F[J] := FUN(X[J]);
    end;
    NOFUN := NOFUN + 8;
    STEP  := (X[16] - X0)/16;

    QLEFT := (W0*(F0   + F[8])+
              W1*(F[1] + F[7])+
              W2*(F[2] + F[6])+
              W3*(F[3] + F[5])+
              W4* F[4]         )*STEP;
    QRIGHT[LEV+1] :=
             (W0*(F[8] + F[16])+
              W1*(F[9] + F[15])+
              W2*(F[10]+ F[14])+
              W3*(F[11]+ F[13])+
              W4* F[12]         )*STEP;
    QNOW  := QLEFT + QRIGHT[LEV+1];
    QDIFF := QNOW  - QPREV;
    AREA  := AREA  + QDIFF;
//
// *** 4***.    
//
    ESTERR := ABS(QDIFF)/1023;
    TOLERR := MAX(ABSERR, RELERR*ABS(AREA)) * (STEP / STONE);

    IF  (LEV < LEVMIN) or
        (
        (Not (LEV >= LEVMAX)) and
        (Not (NOFUN > NOFIN)) and
        (Not (ESTERR <= TOLERR))
        )
    then begin          //   GO TO 50
/////////////////////////////////////////////// 50
// *** 5***  
//   .
//
      NIM := 2*NIM;
      LEV := LEV+1;
//
//  ,         
//  ,   .
//
      for I := 1 to 8 do begin
         FSAVE[I, LEV] := F[I + 8];
         XSAVE[I, LEV] := X[I + 8];
      end;
//
//  ,    
// ,   .
//
      QPREV := QLEFT;
      for I := 1 to 8 do begin
        J := -I;
        F[2*J+18] := F[J + 9];
        X[2*J+18] := X[J + 9];
      end;
      //   while Not QDone  =  GO TO 30
    end
    else begin    // else 50
      IF (ESTERR <= TOLERR) OR (NOFUN > NOFIN ) OR  (LEV >= LEVMAX) then begin
      //   = GO TO 70
        IF (LEV >= LEVMAX) then begin
//////////////////////////////////////////   62
//
//     
//   LEVMAX
//
          FLAG := FLAG + 1.0;
        end  // 62
        else begin // 62
          IF (NOFUN > NOFIN) then begin // GO TO 60
//////////////////////////////////////////   60
// *** 6*** "" 
//      , 
//   .
//
            NOFIN  := 2*NOFIN;
            LEVMAX := LEVOUT;
            FLAG   := FLAG + (B - X0) /(B - A);
          end;  (* 62 *)
   //     GO TO 70
        end; // else 62

//////////////////////////////////////////// 70
//
// *** 7***     
//       .
//
        RESULT := RESULT + QNOW;
        ERREST := ERREST + ESTERR;
        COR11  := COR11  + QDIFF/1023;
//
//   .
//
////////////////////////////////////////////  72
        Q72 := false;
        repeat
          Q72 := (NIM = 2*(NIM div 2));
          if Not Q72 then begin
            NIM := NIM div 2;
            LEV := LEV-1;
          end;
        until Q72;
///////////////////////////////////////////// 75
        NIM := NIM + 1;
        IF (LEV <= 0) then QDone := TRUE;  //      GO TO 80
//
//  ,   
// .
//
        QPREV := QRIGHT[LEV];
        X0    := X[16];
        F0    := F[16];
        for I := 1 to 8 do begin
          F[2*I] := FSAVE[I, LEV];
          X[2*I] := XSAVE[I, LEV];
        end;
      END; //  70
    end; //  else 50
  until QDone;  (* QDone = 30 *)
/////////////////////////////////////////// 80
//
// *** 8***    
//
  RESULT := RESULT + COR11;
//
// ,    ERREST
//     .
//
  IF (ERREST = 0) then Exit;
////////////////////////////////////////// 82
  TEMP := ABS(RESULT) + ERREST;
  while (TEMP = ABS(RESULT)) do begin
    ERREST := 2.0*ERREST;
    TEMP := ABS(RESULT) + ERREST;
  end;
END;


end.
