unit uForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TMainForm = class(TForm)
    Memo: TMemo;
    Button1: TButton;
    edA: TEdit;
    edVMax: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edN: TEdit;
    GroupBox1: TGroupBox;
    btSpline: TSpeedButton;
    btTaylor: TSpeedButton;
    btIntegral: TSpeedButton;
    btHumlicek: TSpeedButton;
    procedure Button1Click(Sender: TObject);
    procedure btSplineClick(Sender: TObject);
    procedure btIntegralClick(Sender: TObject);
    procedure btTaylorClick(Sender: TObject);
    procedure btHumlicekClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses uTypes,uVoigt;

procedure TMainForm.Button1Click(Sender: TObject);
var a,Vmax,V,dV,H,F : real; I,N,IErr : integer;
 S : string;
 SL : TStringList;
begin
  Val(edA.Text,a,IErr);
  if IErr <> 0 then begin
    WarnAbs('   "a"  !');
    Exit;
  end;

  Val(edVmax.Text,VMax,IErr);
  if IErr <> 0 then begin
    WarnAbs('   "Vmax"  !');
    Exit;
  end;

  Val(edN.Text,N,IErr);
  if IErr <> 0 then begin
    WarnAbs('   "N"  !');
    Exit;
  end;

  dV := Vmax / N;

  SL := TStringList.Create;

  S := 'Calculation Metod = <'+uVoigt.sVoigtMethod+'>';
  SL.Add(S);
  S := '   N  a        V        H                F';
  SL.Add(S);

  for I := 0 to N do begin
    V := dV*I;
    VOIGT(a,V,H,F);
    S := ISt(I,4)  +' '+
         FSt(a,7,5)+' '+
         FSt(V,9,6)+' '+
         FSt(H,16,14)+' '+
         FSt(F,16,14);
    SL.Add(S);
  end;

  Memo.Lines := SL;
end;


(*--------      ----------*)
(*                                                             *)
var
  LCursor : TList;

(* PushCursor(crHourGlass); -       *)
procedure PushCursor(C:TCursor);
var P : ^TCursor;
begin
  if Not Assigned(LCursor) then LCursor := TList.Create;
  GetMem(P,SizeOf(TCursor));
  P^ := Screen.Cursor;
  LCursor.Add(P);
  Screen.Cursor := C;
end;

procedure PopCursor;
var N : integer;
begin
  if Assigned(LCursor) and
  (LCursor.Count > 0) then begin
    N := LCursor.Count-1;
    Screen.Cursor := TCursor(LCursor.Items[N]);
    FreeMem(LCursor.Items[N],SizeOf(TCursor));
    LCursor.Delete(N);
  end
  else Screen.Cursor := crDefault;
end;

(*                                                             *)
(*--------      ----------*)



procedure TMainForm.btSplineClick(Sender: TObject);
begin
  PushCursor(crHourGlass); (*       *)
  uVoigt.SetVoigt('Spline');
  PopCursor;
end;

procedure TMainForm.btIntegralClick(Sender: TObject);
begin
  uVoigt.SetVoigt('Integral');
end;

procedure TMainForm.btTaylorClick(Sender: TObject);
begin
  uVoigt.SetVoigt('Taylor');
end;

procedure TMainForm.btHumlicekClick(Sender: TObject);
begin
  uVoigt.SetVoigt('Humlicek');
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  if uVoigt.sVoigtMethod = 'Humlicek'
  then Self.btHumlicek.Down := true
  else
  if uVoigt.sVoigtMethod = 'Taylor'
  then Self.btTaylor.Down := true
  else
  if uVoigt.sVoigtMethod = 'Integral'
  then Self.btIntegral.Down := true
  else
  if uVoigt.sVoigtMethod = 'Spline'
  then Self.btSpline.Down := true;
end;


end.
