unit uTypes;

(*================================================================*)
(*                              *)
(*                                      *)
(*================================================================*)

interface

type

  (*---------------   ---------------*)

  TARe  = array of real;           (*   *)
  TARe2 = array of TARe;           (*    *)

  (*----------------   ----------------*)

  TAR4  = array [1..4] of real;(*   SPLINE4 *)

  (*----------------   ------------------*)

  (*  -                *)
  (*   (    ,   *)
  (*       )  *)
  TFuncEX = function(X:Extended):Extended;

  (*------      ------*)

procedure WarnAbs(S:string);
function Query(S:string):boolean;

  (*----------     -----------*)

function FSt(R:real;N,D:integer):string;
function ISt(I,N:integer):string;

  (*----- /  . -----*)

procedure WrTARe2(A:TARe2;N,M:integer;Nam:string);
procedure RdTARe2(A:TARe2;N,M:integer;Nam:string);


implementation

uses Windows,SysUtils;

(*================================================================*)
(*                 *)
(*================================================================*)

procedure WarnAbs(S:string);
const sHd = '  ';
begin
  Windows.MessageBox(GetActiveWindow,PChar(S),PChar(sHd),MB_OK);
end;

function Query(S:string):boolean;
const sHd = '?';
var IRes : integer;
begin
  IRes := MessageBox(GetActiveWindow,PChar(S),PChar(sHd),MB_YESNO);
  if IRes = 6 then Result := true else Result := false;
end;


(*================================================================*)
(*                   *)
(*================================================================*)

function FSt(R:real;N,D:integer):string;
var S : string;
begin
  Str(R:N:D,S); Result := S;
end;

function ISt(I,N:integer):string;
var S : string;
begin
  S := SysUtils.IntToStr(I);
  while length(S) < N do S := ' '+S;
  result := S;
end;

(*================================================================*)
(*             /         *)
(*                                  *)
(*                         /                          *)
(*================================================================*)

(*        *)
procedure WrTARe2(A:TARe2;N,M:integer;Nam:string);
var ho,I,NN,NR : integer; P : pointer;
begin
  ho := SysUtils.FileCreate(Nam);         (* ho = H-andle of the O-utput file *)
  if ho <= 0 then begin
    WARNAbs('WrTARe2.ERR:     <'+Nam+'> Handle='
             +SysUtils.IntToStr(ho));
    Exit;
  end;
  NR := SizeOf(Real);
  NN := NR*M;    (*     .   Real *)
  for I := 0 to N-1 do begin
    P := pointer(A[I]); (* . 2-.   *)
    SysUtils.FileWrite(ho,P^,NN);              (*      *)
  end;
  SysUtils.FileClose(ho);                      (*                  *)
end;

function GetFHandle(var f):integer;
var fr : System.TFileRec absolute f;
begin GetFHandle := fr.Handle; end;

(*        *)
(*   A:TARe2     ! *)
procedure RdTARe2(A:TARe2;N,M:integer;Nam:string);
var hi,I,NR,NN : integer; P : pointer; F : file;
begin
  if Not SysUtils.FileExists(Nam) then begin
    WarnAbs('RdTARe2 -  <'+Nam+'>  !');
    Exit;
  end;
  Assign(F,Nam); (*$I-*) Reset(F,1); (*$I+*)
  if System.IOResult <> 0 then begin
    WarnAbs('RdTARe2 -  <'+Nam+'>     !');
    Exit;
  end;
  hi := GetFHandle(F);                     (* hi = H-andle of the I-nput file *)
  NR := SizeOf(Real);
  NN := NR*M;
  for I := 0 to N-1 do begin
    P := pointer(A[I]);
    SysUtils.FileRead(hi,P^,NN);
  end;
  SysUtils.FileClose(hi);
end;


end. (* uTypes *)
